<template lang="pug">
  transition(name="scale-fade")
    .modal
      .backdrop.selectable(v-on="{ click: () => { closeByBackdrop ? close() : null } }")
        .wrapper
          .block(v-on:click.stop)
            span.close(v-if="closeButton" v-on:click="close()") &times;
            header
              slot(name="header")
            .content
              slot(name="content")
</template>

<script>
export default {
  name: 'Modal',
  props: {
    closeByBackdrop: {
      default: false,
      type: Boolean
    },
    closeButton: {
      default: false,
      type: Boolean
    }
  },
  data () {
    return {
    }
  },
  methods: {
    close () {
      this.$emit('close')
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../assets/css/effects';

  .modal {
    .wrapper {
      width: 420px;
      margin: 50px auto 15% auto;
    }

    .block {
      position: relative;
      color: #fff;
      background-color: #6b6b6b;
      padding: 30px;
      transition: all 0.3s ease;

      header {
        text-align: center;
        font-size: 16px;
        padding: 0 0 15px 0;
      }

      .content {
        position: relative;
        overflow: auto;
        max-height: calc(100vh - 200px);
      }

      .close {
        color: #aaa;
        float: right;
        font-size: 28px;
        font-weight: bold;
        position: absolute;
        right: 5px;
        top: 0;

        &:hover,
        &:focus {
          color: #fff;
          text-decoration: none;
          cursor: pointer;
        }
      }
    }
  }
</style>
